#import "OCTDetailViewController.h"

@implementation OCTDetailViewController

@synthesize favView;
@synthesize scrollView;
@synthesize toolbar;
@synthesize buttonshowAScan;
@synthesize buttonhideAScan;
@synthesize buttonshowHScan;
@synthesize buttonhideHScan;
@synthesize buttonshowMScan;
@synthesize buttonhideMScan;
@synthesize buttonstartMScan;

#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
	[super viewDidLoad];
	
	// setup scrolling
	scrollView.contentSize = CGSizeMake(703, 240);
	scrollView.showsHorizontalScrollIndicator = NO;
	scrollView.alwaysBounceVertical = YES;
	scrollView.delegate = self;
	
	// add favorites bar
	FavoritesBarViewController *favCon = [[FavoritesBarViewController alloc] initWithNibName:@"FavoritesBarView" bundle:nil];
	[favView addSubview:[favCon view]];
}

- (void)viewDidUnload {
	[super viewDidUnload];	
	self.toolbar = nil;
}

#pragma mark -
#pragma mark Managing the popover

- (void)showRootPopoverButtonItem:(UIBarButtonItem *)barButtonItem {
    
    // Add the popover button to the toolbar.
    NSMutableArray *itemsArray = [toolbar.items mutableCopy];
    [itemsArray insertObject:barButtonItem atIndex:0];
    [toolbar setItems:itemsArray animated:NO];
    [itemsArray release];
}


- (void)invalidateRootPopoverButtonItem:(UIBarButtonItem *)barButtonItem {
    
    // Remove the popover button from the toolbar.
    NSMutableArray *itemsArray = [toolbar.items mutableCopy];
    [itemsArray removeObject:barButtonItem];
    [toolbar setItems:itemsArray animated:NO];
    [itemsArray release];
}


#pragma mark -
#pragma mark Rotation support

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

-(IBAction)buttonshowAScan:(id)sender {
	iPadCom->OCTBasicControl.ShowAScan();
}

-(IBAction)buttonhideAScan:(id)sender {
	iPadCom->OCTBasicControl.HideAScan();
}

-(IBAction)buttonshowHScan:(id)sender {
	iPadCom->OCTBasicControl.ShowHScan();

}

-(IBAction)buttonhideHScan:(id)sender {
	iPadCom->OCTBasicControl.HideHScan();

}

-(IBAction)buttonshowMScan:(id)sender {
	iPadCom->OCTMScanControl.ShowMScan();
}

-(IBAction)buttonhideMScan:(id)sender {
	iPadCom->OCTMScanControl.HideMScan();
}

-(IBAction)buttonstartMScan:(id)sender {
	iPadCom->OCTMScanGenControl.Start();
}


#pragma mark -
#pragma mark Memory management

- (void)dealloc {
    [toolbar release];
    [super dealloc];}	


@end
