#import "VideoDetailViewController.h"

@implementation VideoDetailViewController

@synthesize favView;
@synthesize toolbar;
@synthesize imageView;

#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
	[super viewDidLoad];
	
	NSString *path = [NSString stringWithFormat:@"%@/test_image.bmp",[[NSBundle mainBundle] bundlePath]];
	NSData *imageBuffer = [NSData dataWithContentsOfFile:path];
	[imageView setImage:[UIImage imageWithData:imageBuffer]];
	
	// add favorites bar
	FavoritesBarViewController *favCon = [[FavoritesBarViewController alloc] initWithNibName:@"FavoritesBarView" bundle:nil];
	[favView addSubview:[favCon view]];
}

- (void)viewDidUnload {
	[super viewDidUnload];	
	self.toolbar = nil;
}

#pragma mark -
#pragma mark Managing the popover

- (void)showRootPopoverButtonItem:(UIBarButtonItem *)barButtonItem {
    
    // Add the popover button to the toolbar.
    NSMutableArray *itemsArray = [toolbar.items mutableCopy];
    [itemsArray insertObject:barButtonItem atIndex:0];
    [toolbar setItems:itemsArray animated:NO];
    [itemsArray release];
}


- (void)invalidateRootPopoverButtonItem:(UIBarButtonItem *)barButtonItem {
    
    // Remove the popover button from the toolbar.
    NSMutableArray *itemsArray = [toolbar.items mutableCopy];
    [itemsArray removeObject:barButtonItem];
    [toolbar setItems:itemsArray animated:NO];
    [itemsArray release];
}


#pragma mark -
#pragma mark Rotation support

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}


#pragma mark -
#pragma mark Memory management

- (void)dealloc {
    [toolbar release];
    [super dealloc];
}	


@end
