#import "VisualDetailViewController.h"

@implementation VisualDetailViewController

@synthesize favView;
@synthesize scrollView;
@synthesize toolbar;
@synthesize sliderBrightness;
@synthesize valueBrightness;
@synthesize sliderContrast;
@synthesize valueContrast;
@synthesize sliderGamma;
@synthesize valueGamma;
@synthesize sliderMagnification;
@synthesize valueMagnification;
@synthesize buttonminusHorDisp;
@synthesize buttonplusHorDisp;
@synthesize valueHorDisp;
@synthesize valueVertDisp;
@synthesize buttonminusVertDisp;
@synthesize buttonplusVertDisp;
@synthesize buttonenableAutoExposure;
@synthesize buttondisableAutoExposure;
@synthesize buttonenableBrightnessControl;
@synthesize buttondisableBrightnessControl;
@synthesize buttonenableLightCompounding;
@synthesize buttondisableLightCompounding;
@synthesize buttonenableImageMagnification;
@synthesize buttondisableImageMagnification;
@synthesize buttonenableBackgroundTracking;
@synthesize buttondisableBackgroundTracking;
@synthesize buttonresetBackgroundTracking;
@synthesize buttonenableAnnotations;
@synthesize buttondisableAnnotations;
@synthesize buttonenableVideoStatAnnotations;
@synthesize buttondisableVideoStatAnnotations;
@synthesize buttonstartRecording;
@synthesize buttonpauseRecording;
@synthesize buttonstartVideo;
@synthesize buttonstopVideo;

#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
	[super viewDidLoad];
	
	// setup scrolling
	scrollView.contentSize = CGSizeMake(703, 860);
	scrollView.showsHorizontalScrollIndicator = NO;
	scrollView.alwaysBounceVertical = YES;
	scrollView.delegate = self;
	
	// get initial values
	valueBrightness.text = [[NSString alloc] initWithFormat:@"%d", (int)(visConsole.brightness+0.5)];
	valueContrast.text = [[NSString alloc] initWithFormat:@"%d", (int)(visConsole.contrast+0.5)];
	valueGamma.text = [[NSString alloc] initWithFormat:@"%d", (int)(visConsole.gamma+0.5)];
	valueMagnification.text = [[NSString alloc] initWithFormat:@"%.1f", visConsole.magnification];
	valueHorDisp.text = [[NSString alloc] initWithFormat:@"%d", visConsole.horDispVal];
	valueVertDisp.text = [[NSString alloc] initWithFormat:@"%d", visConsole.vertDispVal];
	
	// set values in sliders
	sliderBrightness.value = visConsole.brightness;
	sliderContrast.value = visConsole.contrast;
	sliderGamma.value = visConsole.gamma;
	sliderMagnification.value = visConsole.magnification*2.0;
	
	// add favorites bar
	FavoritesBarViewController *favCon = [[FavoritesBarViewController alloc] initWithNibName:@"FavoritesBarView" bundle:nil];
	[favView addSubview:[favCon view]];
}

- (void)viewDidUnload {
	[super viewDidUnload];	
	self.toolbar = nil;
}

-(IBAction)sliderBrightnessChanged:(id)sender {
	visConsole.brightness = (double)sliderBrightness.value;
	iPadCom->VideoControl.SetBrightness(visConsole.brightness);
	valueBrightness.text = [[NSString alloc] initWithFormat:@"%d", (int)(visConsole.brightness+0.5)];
}

-(IBAction)sliderContrastChanged:(id)sender {
	visConsole.contrast = (double)sliderContrast.value;
	iPadCom->VideoControl.SetContrast(visConsole.contrast);
	valueContrast.text = [[NSString alloc] initWithFormat:@"%d", (int)(visConsole.contrast+0.5)];
}

-(IBAction)sliderGammaChanged:(id)sender {
	visConsole.gamma = (double)sliderGamma.value;
	iPadCom->VideoControl.SetGamma(visConsole.gamma);
	valueGamma.text = [[NSString alloc] initWithFormat:@"%d", (int)(visConsole.gamma+0.5)];
}

-(IBAction)sliderMagnificationChanged:(id)sender {
	sliderMagnification.value  = (int)(sliderMagnification.value+0.5);
	visConsole.magnification = sliderMagnification.value/2.0;
	iPadCom->VideoControl.SetMagnification(visConsole.magnification);
	valueMagnification.text = [[NSString alloc] initWithFormat:@"%.1f", visConsole.magnification];
}

-(IBAction)buttonminusHorDispPressed:(id)sender {
	visConsole.horDispVal--;
	visConsole.dispVal.Assign(visConsole.horDispVal, visConsole.vertDispVal);
	iPadCom->VideoControl.SetDisparityCorrection(visConsole.dispVal);
	valueHorDisp.text = [[NSString alloc] initWithFormat:@"%d", visConsole.horDispVal];
}

-(IBAction)buttonplusHorDispPressed:(id)sender {
	visConsole.horDispVal++;
	visConsole.dispVal.Assign(visConsole.horDispVal, visConsole.vertDispVal);
	iPadCom->VideoControl.SetDisparityCorrection(visConsole.dispVal);
	valueHorDisp.text = [[NSString alloc] initWithFormat:@"%d", visConsole.horDispVal];
}

-(IBAction)buttonminusVertDispPressed:(id)sender {
	visConsole.vertDispVal--;
	visConsole.dispVal.Assign(visConsole.horDispVal, visConsole.vertDispVal);
	iPadCom->VideoControl.SetDisparityCorrection(visConsole.dispVal);
	valueVertDisp.text = [[NSString alloc] initWithFormat:@"%d", visConsole.vertDispVal];
}

-(IBAction)buttonplusVertDispPressed:(id)sender {
	visConsole.vertDispVal++;
	visConsole.dispVal.Assign(visConsole.horDispVal, visConsole.vertDispVal);
	iPadCom->VideoControl.SetDisparityCorrection(visConsole.dispVal);
	valueVertDisp.text = [[NSString alloc] initWithFormat:@"%d", visConsole.vertDispVal];
}

-(IBAction)buttonenableAutoExposurePressed:(id)sender {
	iPadCom->VideoControl.EnableAutoExposure(true);
}

-(IBAction)buttondisableAutoExposurePressed:(id)sender {
	iPadCom->VideoControl.EnableAutoExposure(false);
}

-(IBAction)buttonenableBrightnessControlPressed:(id)sender {
	iPadCom->VideoControl.EnableBrightnessControl(true);
}

-(IBAction)buttondisableBrightnessControlPressed:(id)sender {
	iPadCom->VideoControl.EnableBrightnessControl(false);
}

-(IBAction)buttonenableLightCompoundingPressed:(id)sender {
	iPadCom->VideoControl.EnableLightSourceCompounding(true);
}

-(IBAction)buttondisableLightCompoundingPressed:(id)sender {
	iPadCom->VideoControl.EnableLightSourceCompounding(false);
}

-(IBAction)buttonenableImageMagnificationPressed:(id)sender {
	iPadCom->VideoControl.EnableImageMagnification(true);
}

-(IBAction)buttondisableImageMagnificationPressed:(id)sender {
	iPadCom->VideoControl.EnableImageMagnification(false);
}

-(IBAction)buttonenableBackgroundTrackingPressed:(id)sender {
	iPadCom->VideoControl.EnableBackgroundTracking(true);
	iPadCom->VideoControl.EnableBgTrackingAnnotations(true);
}

-(IBAction)buttondisableBackgroundTrackingPressed:(id)sender {
	iPadCom->VideoControl.EnableBackgroundTracking(false);
	iPadCom->VideoControl.EnableBgTrackingAnnotations(false);
}

-(IBAction)buttonresetBackgroundTrackingPressed:(id)sender {
	iPadCom->VideoControl.ResetBackgroundTracking();
}

-(IBAction)buttonenableAnnotationsPressed:(id)sender {
	iPadCom->VideoControl.EnableAnnotations(true);
}

-(IBAction)buttondisableAnnotationsPressed:(id)sender {
	iPadCom->VideoControl.EnableAnnotations(false);
}

-(IBAction)buttonenableVideoStatAnnotationsPressed:(id)sender {
	iPadCom->VideoControl.EnableVideoStatAnnotations(true);
}

-(IBAction)buttondisableVideoStatAnnotationsPressed:(id)sender {
	iPadCom->VideoControl.EnableVideoStatAnnotations(false);
}

-(IBAction)buttonstartRecordingPressed:(id)sender {
	iPadCom->VideoControl.StartRecording();
}

-(IBAction)buttonpauseRecordingPressed:(id)sender {
	iPadCom->VideoControl.PauseRecording();
}

-(IBAction)buttonstartVideoPressed:(id)sender {
	iPadCom->VideoControl.StartVideo();
}

-(IBAction)buttonstopVideoPressed:(id)sender {
	iPadCom->VideoControl.StopVideo();
}

#pragma mark -
#pragma mark Managing the popover

- (void)showRootPopoverButtonItem:(UIBarButtonItem *)barButtonItem {
    
    // Add the popover button to the toolbar.
    NSMutableArray *itemsArray = [toolbar.items mutableCopy];
    [itemsArray insertObject:barButtonItem atIndex:0];
    [toolbar setItems:itemsArray animated:NO];
    [itemsArray release];
}


- (void)invalidateRootPopoverButtonItem:(UIBarButtonItem *)barButtonItem {
    
    // Remove the popover button from the toolbar.
    NSMutableArray *itemsArray = [toolbar.items mutableCopy];
    [itemsArray removeObject:barButtonItem];
    [toolbar setItems:itemsArray animated:NO];
    [itemsArray release];
}


#pragma mark -
#pragma mark Rotation support

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}


#pragma mark -
#pragma mark Memory management

- (void)dealloc {
    [toolbar release];
    [super dealloc];
}	

@end
