#include "iPadInterface.h"

/***************************/
/*** iPadInterface class ***/
/***************************/

const std::string ProcessName = "iPadProcess";
const std::string ComponentName = "iPadComponent";
CMN_IMPLEMENT_SERVICES(iPadInterface);

iPadInterface::iPadInterface() :
    mtsTaskPeriodic(ComponentName, 10.0 * cmn_ms),
    VideoControl("RequiresVideoControl", this),
    OCTBasicControl("RequiresOCTBasicControl", this),
    OCTMScanControl("RequiresOCTMScanControl", this),
	OCTMScanGenControl("RequiresOCTMScanGenControl", this) {
}

iPadInterface::~iPadInterface() {
}

void iPadInterface::Configure(const std::string & CMN_UNUSED(filename)) {
}

void iPadInterface::Startup() {
    mtsComponentManager::GetInstance()->Connect(ProcessName,
                                                ComponentName,
                                                "RequiresVideoControl",
                                                "VisualizationProcess",
                                                "VisualizationManager",
                                                "ProvidesVideoControl",
                                                3);

    mtsComponentManager::GetInstance()->Connect(ProcessName,
                                                ComponentName,
                                                "RequiresOCTBasicControl",
                                                "VisualizationProcess",
                                                "BehaviorOCTBasic",
                                                "ProvidesOCTBasicControl",
                                                3);

    mtsComponentManager::GetInstance()->Connect(ProcessName,
                                                ComponentName,
                                                "RequiresOCTMScanControl",
                                                "VisualizationProcess",
                                                "BehaviorOCTMScan",
                                                "ProvidesOCTMScanControl",
                                                3);
	
	mtsComponentManager::GetInstance()->Connect(ProcessName,
                                                ComponentName,
                                                "RequiresOCTMScanGenControl",
                                                "OCTProc",
                                                "MScanGenerator",
                                                "ProvidesMScan",
                                                1);
}

void iPadInterface::Run() {
    ProcessQueuedEvents();
    ProcessQueuedCommands();
}

void iPadInterface::Cleanup() {
	
}