#ifndef _iPadInterface_h
#define _iPadInterface_h

#include <cisstMultiTask/mtsTaskPeriodic.h>
#include <cisstMultiTask/mtsFunctionWrite.h>
#include "usrgVisRequiredInterfaces.h"


class iPadInterface : public mtsTaskPeriodic
{
    CMN_DECLARE_SERVICES(CMN_NO_DYNAMIC_CREATION, CMN_LOG_LOD_RUN_ERROR);

public:
    iPadInterface();
    ~iPadInterface();

public:
    void Configure(const std::string & filename);
    void Startup();
    void Run();
    void Cleanup();

public:
    IReqVideoControl    VideoControl;
    IReqOCTBasicControl OCTBasicControl;
    IReqOCTMScanControl OCTMScanControl;
	IReqOCTMScanGenControl OCTMScanGenControl;
};

CMN_DECLARE_SERVICES_INSTANTIATION(iPadInterface);

#endif // _iPadInterface_h

